﻿//Создание объекта игра
var game = new Phaser.Game(960, 720, Phaser.AUTO, 'gamediv', '', true);



var bootState = new Phaser.State(); // state для загрузки картинок для State0 - преролла, базовые настройки игры.

game.state.add('Boot', bootState, false);
game.state.start('Boot');


bootState.preload = function () {
   
    var i;

    
    
    //Загрузка картинок для преролла State0

    game.load.image('start_background', 'assets/preroll_bg.png');
    game.load.image('logo_big', 'assets/logo_big.png');
  

    
    game.stage.disableVisibilityChange = true; // игра не останавливается при потери фокуса
    
    game.world.setBounds(0, 0, 1431, 720);

    //настройки автомасштабирования игры в барузере по раземеру фрейма.
    game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
    game.scale.pageAlignHorizontally = true;
    game.scale.pageAlignVertically = true;
    game.scale.parentIsWindow = true
    game.scale.refresh();

    //загрузка конфигураций экранов
    game.load.json("common", 'assets/common.json');

    console.log("load json configs")
    for (i = 1; i < g_stateCount; i++) { //пока не грузим преролл
        //грузим картинки
        
        var stateName = 'state' + i;

        console.log("load json for " + stateName);

        game.load.json(stateName, 'assets/state' + i + '/' + stateName + '.json');

        //грузим действия
        var stateActions = 'state' + i + 'actions';
        game.load.json(stateActions, 'assets/state' + i + '/' + stateActions + '.json');
    }

    g_Elsa = new GameObject('elsa');
    g_Elsa.loadConfig();
    
    g_Bel = new GameObject('bel');
    g_Bel.loadConfig();
    
    g_Ariel = new GameObject('ariel');
    g_Ariel.loadConfig();
    
    g_Rap = new GameObject('rap');
    g_Rap.loadConfig();

    

}

bootState.create = function () {
    game.state.start('State0');
}