﻿//Файл экрана

var state0 = new Phaser.State();
var loadText;

var RenderCount = 0;

game.state.add('State0', state0, false);

function LoadResources(_Items)
{
   // console.log("Items.ItemsCount: " + _Items.ItemsCount)
   for (var k = 0; k < _Items.ItemsCount; k++) {
       if (_Items.Items[k].Type != "group" && _Items.Items[k].Type != "virtual") { //парсим не групповые ресурсы
           //console.log("load in cache : " + _Items.Items[k].Name)
            if (parseInt(_Items.Items[k].FrameCount) == 1) {
                game.load.image(_Items.Items[k].Name, 'assets/' + _Items.Items[k].Path.toString().replace('./', ''));
            }
            else {
                game.load.spritesheet(_Items.Items[k].Name, 'assets/' + _Items.Items[k].Path.toString().replace('./', ''), parseInt(_Items.Items[k].SizeX), parseInt(_Items.Items[k].SizeY), parseInt(_Items.Items[k].FrameCount));
            }
        }
       else { //парсим группу
         //  console.log("LoadResources from group: " + k)
            LoadResources(_Items.Items[k]);
        }
    }
}

state0.preload = function (){

    var i;
    var k;
    var stateName;
    var stateConfig;
    
    // загружаем картинки преролла
    game.add.tileSprite(0, 0, 960, 720, 'start_background');
    game.add.button(295, 275, 'logo_big', actionLogoOnClick, this);

   
    loadText = game.add.text(400, 575, 'Loading ...', { fill: '#ffffff' });

    console.log("Begin load all resources");

    //Начинаем грузить ресурсы игры для всех экранов
    
    for (i = 1; i <= g_stateCount; i++) { //пока не грузим преролл
        stateName = 'state' + i;
        if (i == g_stateCount)
        {
            stateName = "common";
        }
        console.log(stateName);
        stateConfig = game.cache.getJSON(stateName);
        LoadResources(stateConfig);
    }

    g_Elsa.loadResources();
    g_Bel.loadResources();
    g_Ariel.loadResources();
    g_Rap.loadResources();
    
  //  g_Cindy.loadResources();

    //game.load.image('cup1', 'assets/state3/1_cup1.png');

    game.load.spritesheet('play_big', 'assets/play_big_sheet.png', 185, 77, 4);

    game.load.audio('gamesound', ['assets/sound.mp3', 'assets/sound.ogg']);
    
    game.load.onLoadStart.add(loadStart, this);
    game.load.onFileComplete.add(fileComplete, this);
    game.load.onLoadComplete.add(loadComplete, this);

    game.input.onDown.add(prerollClick, this);

    InitProgram();
    
    
   

    //создаем игровые состояния
    var state1 = new Phaser.State();
    game.state.add('state1', state1, false);
    g_States.push(new GameState(state1, 'state1', 1));

    state1.create = function () {

        if (g_StateNumber == 0) {
            console.log("start music");
            g_Music = game.add.audio('gamesound');
            g_Music.play('', 0, 1, true);
            g_MusicOn = true;
        }

        g_StateNumber = 1;
        
       // game.input.onDown.add(g_States[2].processOnDown, g_States[2]);

        InitProgram();


        
       
        g_States[0].create(false);

 

    }

    state1.update = function () {
        if (g_States[0].needReorder == true) {
            g_States[0].needReorder = false;
            g_States[0].reorder();
        }
        
      
    }

    var state2 = new Phaser.State();
    game.state.add('state2', state2, false);
    g_States.push(new GameState(state2, 'state2', 2));

    state2.create = function () {
        g_StateNumber = 2;
        g_CurState = g_States[1];
        g_st2status = 0; //открытие экрана

        g_CurState.create(true);
        g_CurState.getCommonByName("next").changeVisible(false);
     

       
    }
    
    

    state2.update = function () {
        if (g_States[1].needReorder == true) {
            g_States[1].needReorder = false;
            g_States[1].reorder();
        }

        if (g_States[1].stateTime > 7500 && g_st2status==0)
        {
            console.log("visible next");
            g_CurState.getCommonByName("next").changeVisible(true);
            g_st2status = 1;
        }
    }

   // g_States[1].gameObjects.push(g_Anna);
    //g_States[1].gameObjects.push(g_Elsa);


    //Создаем одевалку
    var state3 = new Phaser.State();
    game.state.add('state3', state3, false);
    g_States.push(new GameState(state3, 'state3', 3));

    state3.create = function () {
        g_StateNumber = 3;
       
        game.world.setBounds(0, 0, 1431, 720);
        
        g_CurState = g_States[2];
        
        g_CurState.addObject(g_Elsa);
        g_CurState.addObject(g_Bel);
        g_CurState.addObject(g_Ariel);
        g_CurState.addObject(g_Rap);
   
        g_Elsa.z = 0;
        g_Elsa.move(250, gGirlY);
        
        g_Bel.z = 0;
        g_Bel.move(250, gGirlY);
        
        g_Ariel.z = 0;
        g_Ariel.move(250, gGirlY);
//        
        g_Rap.z = 0;
        g_Rap.move(250, gGirlY);
        

        g_CurState.create(true);
        g_CurState.cameraEnable(true);
        //обработка нажатий мышки
        game.input.onDown.add(g_CurState.processOnDown, g_CurState);
        game.input.onUp.add(g_CurState.processOnUp, g_CurState);
        game.input.addMoveCallback(g_CurState.processMovement, g_CurState);
        
        g_CurState.getItemByName("3_left").display.onInputDown.add(leftDown,this);
        g_CurState.getItemByName("3_left").display.onInputUp.add(leftUp,this);
        
        g_CurState.getItemByName("3_right").display.onInputDown.add(rightDown,this);
        g_CurState.getItemByName("3_right").display.onInputUp.add(rightUp,this);
        
        InitState3();
        
    
    }
    
    

    state3.update = function ()
    {
        if (g_States[2].needReorder == true)
        {
            g_States[2].needReorder = false;
            g_States[2].reorder();
        }

        if (g_leftButtonTap == true)
        {
        	g_CurState.moveCamera(10);
        }
        if (g_rightButtonTap == true)
        {
        	g_CurState.moveCamera(-10);
        }

    }

  //Создаем одевалку
    var state4 = new Phaser.State();
    game.state.add('state4', state4, false);
    g_States.push(new GameState(state4, 'state4', 4));

    state4.create = function () {
        g_StateNumber = 4;
       
        
        g_CurState = g_States[3];
        
//        g_Elsa.destroy();
//        g_Ariel.destroy();
//        g_Bel.destroy();
//        g_Rap.destroy();
        
        g_CurState.addObject(g_Elsa);
        g_CurState.addObject(g_Bel);
        g_CurState.addObject(g_Ariel);
        g_CurState.addObject(g_Rap);
   
        
        
        g_Bel.z = 2;
        g_Bel.move(250, 20);
        
        g_Elsa.z = 3;
        g_Elsa.move(50, 40);
        
        g_Ariel.z = 4;
        g_Ariel.move(400, 55);
//        
        g_Rap.z = 1;
        //g_Rap.move(350, 40);
        g_Rap.move(-100, 0);
        
//        for (var k=0;k<g_CurState.gameObjects.length;k++)
//    	{
//    		g_CurState.gameObjects[k].values['dress'] = 9;
//    		g_CurState.gameObjects[k].values['hair'] = 1;
//    		g_CurState.gameObjects[k].values['hair_back'] = 1;
//    	}	
        

        g_CurState.create(true);
     //   g_CurState.cameraEnable(true);
        //обработка нажатий мышки
        game.input.onDown.add(g_CurState.processOnDown, g_CurState);
        game.input.onUp.add(g_CurState.processOnUp, g_CurState);
        game.input.addMoveCallback(g_CurState.processMovement, g_CurState);
        
        g_CurState.getCommonByName("next").changeVisible(false);
               
        for (var k=0;k<g_CurState.gameObjects.length;k++)
		{
        	g_CurState.gameObjects[k].visible=true;
			g_CurState.gameObjects[k].redraw();
		}
        g_Bel.rescaleXY(0.95,0.95);
        g_Rap.rescaleXY(0.95,0.95);
        g_Elsa.rescaleXY(-0.8,0.8);
        g_Ariel.rescaleXY(-0.8,0.8);
        
        g_Bel.remove(200,50);
        g_Rap.remove(-100,60);
        g_Elsa.remove(480,100);
        g_Ariel.remove(750,120);
//        InitState4();
      //  g_CurState.reorder();
    
    }

    state4.update = function ()
    {
        if (g_CurState.needReorder == true)
        {
        	g_CurState.needReorder = false;
        	g_CurState.reorder();
        }


    }
    
    var state5 = new Phaser.State();
    game.state.add('state5', state5, false);
    g_States.push(new GameState(state5, 'state5', 5));

    state5.create = function () {
        g_StateNumber = 5;
       
        g_st5status=0;
        g_CurState = g_States[4];
        
        game.world.setBounds(0, 0, 1329, 720);
        
//        g_Elsa.destroy();
//        g_Ariel.destroy();
//        g_Bel.destroy();
//        g_Rap.destroy();
        
        g_CurState.addObject(g_Elsa);
        g_CurState.addObject(g_Bel);
        g_CurState.addObject(g_Ariel);
        g_CurState.addObject(g_Rap);
   
        
        
        g_Bel.z = 2;
        g_Bel.move(250, 20);
        
        g_Elsa.z = 3;
        g_Elsa.move(50, 40);
        
        g_Ariel.z = 4;
        g_Ariel.move(400, 55);
//        
        g_Rap.z = 1;
        //g_Rap.move(350, 40);
        g_Rap.move(-100, 0);
       
        

        g_CurState.create(true);
        g_CurState.cameraEnable(false);
        //обработка нажатий мышки
        game.input.onDown.add(g_CurState.processOnDown, g_CurState);
        game.input.onUp.add(g_CurState.processOnUp, g_CurState);
        game.input.addMoveCallback(g_CurState.processMovement, g_CurState);
        
        g_CurState.getCommonByName("next").changeVisible(false);
        g_CurState.getItemByName("5_fon"+g_st5fon).changeVisible(true);
        
 //       g_Girl=0;
        for (var k=0;k<g_CurState.gameObjects.length;k++)
		{
 //       	SwitchGirl(g_CurState.gameObjects[k].name);
        	g_CurState.gameObjects[k].visible=true;
			g_CurState.gameObjects[k].redraw();
		}
       // InitState4();
        g_Bel.rescaleXY(0.95,0.95);
        g_Rap.rescaleXY(0.95,0.95);
        g_Elsa.rescaleXY(-0.8,0.8);
        g_Ariel.rescaleXY(-0.8,0.8);
        
        g_Bel.remove(350,50);
        g_Rap.remove(050,60);
        g_Elsa.remove(600,110);
        g_Ariel.remove(900,120);
    
    }

    state5.update = function ()
    {
        if (g_CurState.needReorder == true)
        {
        	g_CurState.needReorder = false;
        	g_CurState.reorder();
        }
       
        if (g_CurState.stateTime > 2500 && g_st5status==0)
        {
        	//g_CurState.cameraEnable(false);
            console.log("visible replay");
            g_CurState.getCommonByName("replay").changeVisible(true);
            g_st5status = 1;
        }
    }



}

onTapStart = function()
{
	console.log("onTap");
}
    
state0.create = function () {
       
        game.add.button(387, 500, 'play_big', prerollPlayClick, this, 1, 2, 3);
        
        g_StateNumber=0;
        

  //    game.state.start('state3');
    }

    function loadStart() {

        loadText.setText("Loading ...");

    }

    function fileComplete(progress, cacheKey, success, totalLoaded, totalFiles) {

        loadText.setText("Loading " + progress + "%");
    }

    function loadComplete() {

        loadText.setText("Load Complete");
        loadText.destroy();

    }

    function prerollClick() {
        var x;
        var y;
        var n;
        x = game.input.x;
        y = game.input.y;
        if (x >= 323 && x <= 637 && y >= 500 && y <= 665) {
            return;

        }
        window.open("http://freegamescasual.com/?owngames_PrincessesComicsHeroinesHTML=", "_blank");
    }

    function prerollPlayClick() {
        game.state.start('state1');
    }
